package com.sa.ibiz.demo.mob.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import lombok.Data;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.demo.domain.OrgUser;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import java.util.Map;
import java.util.Date;
import org.springframework.cglib.beans.BeanCopier;
import javax.validation.constraints.Size;
import java.util.UUID;
import org.springframework.cglib.beans.BeanCopier;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class OrgUser_EditForm_UserInfoForm{

    @JsonProperty(access=Access.WRITE_ONLY)
    private Map<String,String> srfparentdata;
    @JsonIgnore
    private Timestamp updatedate;
    @JsonProperty(access=Access.WRITE_ONLY)
    private String srforikey;
    @JsonIgnore
    private String orguserid;
    @JsonIgnore
    private String orgusername;
    @JsonIgnore
    private String srftempmode;
    @JsonProperty
    private String srfuf;
    @JsonProperty
    private String srfdeid;
    @JsonProperty(access=Access.WRITE_ONLY)
    private String srfsourcekey;
    @JsonIgnore
    private String orgsectorname;
    @JsonIgnore
    private String reserver;

    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JsonProperty(value = "srfupdatedate")
    public Timestamp getSrfupdatedate(){
        return updatedate;
    }
    @JsonProperty(value = "srfupdatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    public void setSrfupdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
    }

    @JsonProperty(value = "srforikey")
    public String getSrforikey(){
        return srforikey;
    }
    @JsonProperty(value = "srforikey")
    public void setSrforikey(String srforikey){
        this.srforikey = srforikey;
    }

    @Size(min = 0, max = 100, message = "[组织人员标识]长度必须在[100]以内!")
    @JsonProperty(value = "srfkey")
    public String getSrfkey(){
        return orguserid;
    }
    @JsonProperty(value = "srfkey")
    public void setSrfkey(String orguserid){
        this.orguserid = orguserid;
    }

    @Size(min = 0, max = 200, message = "[人员名称]长度必须在[200]以内!")
    @JsonProperty(value = "srfmajortext")
    public String getSrfmajortext(){
        return orgusername;
    }

    @JsonProperty(value = "srftempmode")
    public String getSrftempmode(){
        return srftempmode;
    }
    @JsonProperty(value = "srftempmode")
    public void setSrftempmode(String srftempmode){
        this.srftempmode = srftempmode;
    }

    @JsonProperty(value = "srfdeid")
    public String getSrfdeid(){
        return srfdeid;
    }
    @JsonProperty(value = "srfdeid")
    public void setSrfdeid(String srfdeid){
        this.srfdeid = srfdeid;
    }

    @Size(min = 0, max = 200, message = "[所属部门]长度必须在[200]以内!")
    @JsonProperty(value = "orgsectorname")
    public String getOrgsectorname(){
        if(StringUtils.isEmpty(orgsectorname)){
        if(isCreate()){
            this.orgsectorname=AuthenticationUser.getAuthenticationUser().getSessionParams().get("srforgsectorname");
        }
        }
        return orgsectorname;
    }
    @JsonProperty(value = "orgsectorname")
    public void setOrgsectorname(String orgsectorname){
        this.orgsectorname = orgsectorname;
    }

    @Size(min = 0, max = 100, message = "[保留字段]长度必须在[100]以内!")
    @JsonProperty(value = "reserver")
    public String getReserver(){
        return reserver;
    }
    @JsonProperty(value = "reserver")
    public void setReserver(String reserver){
        this.reserver = reserver;
    }

    @Size(min = 0, max = 200, message = "[人员名称]长度必须在[200]以内!")
    @JsonProperty(value = "orgusername")
    public String getOrgusername(){
        if(StringUtils.isEmpty(orgusername)){
        if(isCreate()){
            this.orgusername=AuthenticationUser.getAuthenticationUser().getSessionParams().get("srfusername");
        }
        }
        return orgusername;
    }
    @JsonProperty(value = "orgusername")
    public void setOrgusername(String orgusername){
        this.orgusername = orgusername;
    }

    @Size(min = 0, max = 100, message = "[组织人员标识]长度必须在[100]以内!")
    @JsonProperty(value = "orguserid")
    public String getOrguserid(){
        return orguserid;
    }
    @JsonProperty(value = "orguserid")
    public void setOrguserid(String orguserid){
        this.orguserid = orguserid;
    }

    public  void fromOrgUser(OrgUser sourceEntity)  {
        this.fromOrgUser(sourceEntity,true);
    }

     /**
	 * do转换为vo
	 * @param sourceEntity do数据对象
	 * @return
	 */
    public  void fromOrgUser(OrgUser sourceEntity,boolean reset)  {
      BeanCopier copier=BeanCopier.create(OrgUser.class, OrgUser_EditForm_UserInfoForm.class, false);
      copier.copy(sourceEntity,this,  null);
      this.toString();
	}

    /**
	 * vo转换为do
	 * @param
	 * @return
	 */
    public  OrgUser toOrgUser()  {
        OrgUser targetEntity =new OrgUser();
        BeanCopier copier=BeanCopier.create(OrgUser_EditForm_UserInfoForm.class, OrgUser.class, false);
        copier.copy(this, targetEntity, null);
        return targetEntity;
	}

     /**
	 * 新建
	 * @param
	 * @return
	 */
    private boolean isCreate()
    {
    	if((StringUtils.isEmpty(this.srfuf))||this.srfuf.equals("0"))
	    	return true;
    	else
    	    return false;
    }
     /**
	 * 更新
	 * @param
	 * @return
	 */
    private boolean isUpdate()
    {
    	if((!StringUtils.isEmpty(this.srfuf))&&this.srfuf.equals("1"))
	    	return true;
    	else
    	    return false;
    }

}
